/*
 *  Envelope.h
 *  audioOutputExample
 *
 *  Created by Zach Gage on 4/19/11.
 *  Copyright 2011 stfj. All rights reserved.
 *
 */

#include "ofMain.h"

class Envelope{
	
	public:
	
	Envelope();
	~Envelope();
	void setup(int tableSize); //defaults to 32 samples
	void setTableValue(int index, float value); //sets a specific value in the envelope, envelope defaults to a sin wave
	float getEnvelopeValue(float pct); // returns the value at the specified percentage
	
	void draw(int x, int y, int w=100, int h=25);
	
	int getTableSize();
	
protected:
	int size;
	float * table;
	
	void createDefaultEnvelope(); //fills the envelope with default values (sin wave)
};